package cpmodel;

import localsearch.solvers.complete.SoftSolver;

public class CPBenchmark {
	protected String[] modelname;
	protected int[] modeltype;
	protected int[] heuristic;
	protected int nlModels;
	protected int nhModels;
	protected int nsModels;

	protected String[] bench;
	protected int nBenchs;

	protected int[][] node;
	protected int[][] time;
	protected int[][] iteration;
	protected int[][] nogood;
	protected int[][] score;

	protected int timelimit = 420000;

	public CPBenchmark() {
		super();
	}

	public void setSoftExp()
	{
		SoftLightModel.printCPResolution = false;
		nBenchs = 10;
		bench = new String[nBenchs];

		bench[0] = "data/Track2/comp-2007-2-3.tim";
		bench[1] = "data/Track2/comp-2007-2-4.tim";
		bench[2] = "data/Track2/comp-2007-2-5.tim";
		bench[3] = "data/Track2/comp-2007-2-6.tim";
		bench[4] = "data/Track2/comp-2007-2-7.tim";
		bench[5] = "data/Track2/comp-2007-2-8.tim";
		bench[6] = "data/Track2/comp-2007-2-11.tim";
		bench[7] = "data/Track2/comp-2007-2-12.tim";
		bench[8] = "data/Track2/comp-2007-2-15.tim";
		bench[9] = "data/Track2/comp-2007-2-16.tim";

		nlModels = 0;
		nhModels = 0;
		nsModels = 2;

		time = new int[nBenchs][nhModels+nlModels+nsModels];
		node = new int[nBenchs][nhModels+nlModels+nsModels];
		iteration = new int[nBenchs][nhModels+nlModels+nsModels];
		nogood = new int[nBenchs][nhModels+nlModels+nsModels];
		score = new int[nBenchs][nhModels+nlModels+nsModels];

		modelname = new String[nhModels+nlModels+nsModels];
		modeltype = new int[nhModels+nlModels+nsModels];
		heuristic = new int[nhModels+nlModels+nsModels];


		modelname[nhModels+nlModels+0] = "~Model~\\ref{lightmodel} (soft)";
		modelname[nhModels+nlModels+1] = "~Model~\\ref{lightmodel} (lds-5)";
	//	modelname[nhModels+nlModels+2] = "~Model~\\ref{lightmodel} (lds)";

		heuristic[nhModels+nlModels+0] = LightModel.Impact;
		heuristic[nhModels+nlModels+1] = LightModel.Impact;
	//	heuristic[nhModels+nlModels+2] = LightModel.Impact;

		modeltype[nhModels+nlModels+0] = PrimalModel.R_ALLDIFF;
		modeltype[nhModels+nlModels+1] = PrimalModel.R_ALLDIFF;
	//	modeltype[nhModels+nlModels+2] = PrimalModel.R_ALLDIFF;

	}


	public void setAllExp()
	{
		SoftLightModel.printCPResolution = false;
		nBenchs = 10;
		bench = new String[nBenchs];

		bench[0] = "data/Track2/comp-2007-2-3.tim";
		bench[1] = "data/Track2/comp-2007-2-4.tim";
		bench[2] = "data/Track2/comp-2007-2-5.tim";
		bench[3] = "data/Track2/comp-2007-2-6.tim";
		bench[4] = "data/Track2/comp-2007-2-7.tim";
		bench[5] = "data/Track2/comp-2007-2-8.tim";
		bench[6] = "data/Track2/comp-2007-2-11.tim";
		bench[7] = "data/Track2/comp-2007-2-12.tim";
		bench[8] = "data/Track2/comp-2007-2-15.tim";
		bench[9] = "data/Track2/comp-2007-2-16.tim";

		nlModels = 4;
		nhModels = 1;
		nsModels = 3;

		time = new int[nBenchs][nhModels+nlModels+nsModels];
		node = new int[nBenchs][nhModels+nlModels+nsModels];
		iteration = new int[nBenchs][nhModels+nlModels+nsModels];
		nogood = new int[nBenchs][nhModels+nlModels+nsModels];
		score = new int[nBenchs][nhModels+nlModels+nsModels];

		modelname = new String[nhModels+nlModels+nsModels];
		modeltype = new int[nhModels+nlModels+nsModels];
		heuristic = new int[nhModels+nlModels+nsModels];



		modelname[0] = "~Model~\ref{heavymodel}~";

		modelname[nhModels+0] = "~Model~\\ref{lightmodel} (conf) - Impact~";
		modelname[nhModels+1] = "~Model~\\ref{lightmodel} (all) - Impact~";
		modelname[nhModels+2] = "~Model~\\ref{lightmodel} (room) - Impact~";
		modelname[nhModels+3] = "Contention";
		modelname[nhModels+4] = "~Dom/Deg~";

		modelname[nhModels+nlModels+0] = "~Model~\\ref{lightmodel} (soft)";
		modelname[nhModels+nlModels+1] = "~Model~\\ref{lightmodel} (lds)";
		modelname[nhModels+nlModels+2] = "~Model~\\ref{lightmodel} (lds-5)";


		heuristic[0] = LightModel.Impact;
		heuristic[nhModels+0] = LightModel.Impact;
		heuristic[nhModels+1] = LightModel.Impact;
		heuristic[nhModels+2] = LightModel.Impact;
		heuristic[nhModels+3] = LightModel.CODCON;
		heuristic[nhModels+4] = LightModel.DODLEX;
		heuristic[nhModels+nlModels+0] = LightModel.Impact;
		heuristic[nhModels+nlModels+1] = LightModel.Impact;
		heuristic[nhModels+nlModels+2] = LightModel.Impact;

		modeltype[0] = PrimalModel.R_ALLDIFF;
		modeltype[nhModels+0] = PrimalModel.CONFLICTS;
		modeltype[nhModels+1] = PrimalModel.A_ALLDIFF;
		modeltype[nhModels+2] = PrimalModel.R_ALLDIFF;
		modeltype[nhModels+3] = PrimalModel.R_ALLDIFF;
		modeltype[nhModels+4] = PrimalModel.R_ALLDIFF;
		modeltype[nhModels+nlModels+0] = PrimalModel.R_ALLDIFF;
		modeltype[nhModels+nlModels+1] = PrimalModel.R_ALLDIFF;
		modeltype[nhModels+nlModels+2] = PrimalModel.R_ALLDIFF;

	}


	public void setSmallExp()
	{
		//InstanceReader.prevchg = true;

		SoftLightModel.printCPResolution = true;
		nBenchs = 1;
		bench = new String[nBenchs];

		bench[0] = "data/small2008/small1.tim";
		//bench[0] = "data/Track2/comp-2007-2-8.tim";


		nlModels = 0;
		nhModels = 0;
		nsModels = 2;

		time = new int[nBenchs][nhModels+nlModels+nsModels];
		node = new int[nBenchs][nhModels+nlModels+nsModels];
		iteration = new int[nBenchs][nhModels+nlModels+nsModels];
		nogood = new int[nBenchs][nhModels+nlModels+nsModels];
		score = new int[nBenchs][nhModels+nlModels+nsModels];

		modelname = new String[nhModels+nlModels+nsModels];
		modeltype = new int[nhModels+nlModels+nsModels];
		heuristic = new int[nhModels+nlModels+nsModels];


		modelname[nhModels+nlModels+0] = "~Model~\\ref{lightmodel} (soft)";

		heuristic[nhModels+nlModels+0] = LightModel.Impact;

		modeltype[nhModels+nlModels+0] = PrimalModel.R_ALLDIFF;

	}



	public static double[] speed =
		new double[]{ 0.12, 0.16, 0.09, 0.16, 0.08, 0.05, 0.05, 0.05, 0.14, 0.18, 0.11, 0.14, 0.09, 0.07, 0.04, 0.09 };

	public static double[]  avgIterPersec = new double[]{0.11909449999999999,0.15023535,0.09097875,0.16435150000000004,0.114209904999999999,0.05315150000000002,0.03875579999999999,0.17934155000000002,0.12287785,0.10639799999999999,0.08588235000000001,0.10475985000000002,0.10314090000000001,0.0766734,0.06138555000000001,0.27690965};


	public void launch()
	{

		for(int i = 0; i < nBenchs; i++)
		{

			for(int j = 0; j < nhModels; j++)
			{
				////////// Heavy model

				System.out.println("solve " + bench[i] + " with Heavy model");

				HeavyModel hmodel = new HeavyModel( bench[i] );

				hmodel.heuristictype = PrimalModel.Impact;
				hmodel.buildModel();
				hmodel.setTimeLimit(timelimit);
				hmodel.solve();

		        time[i][j] = hmodel.getTime();
		        node[i][j] = hmodel.getNode();
		        iteration[i][j] = (hmodel.nIterations + 1);
		        nogood[i][j] = hmodel.nNogoods;

		        if( hmodel.pb.isFeasible() == Boolean.TRUE) {

		        	hmodel.checkSolution();
			        System.out.print("SAT     ");

		        } else if (hmodel.pb.isFeasible() == Boolean.FALSE) {
		        	System.out.print("UNSAT   ");
		        } else System.out.print("UNKnown ");
		        System.out.println( node[i][j] + " NDS, " + time[i][j] + " ms, "
		        		+ (hmodel.nIterations + 1) + " iterations, "
		        		+ hmodel.nNogoods + " nogoods learned\n" );
			}

			for(int j = nhModels; j < nhModels+nlModels; j++)
			{


				//SoftLightModel model = new SoftLightModel( bench[i], heuristic[j] );
				LightModel model = new LightModel( bench[i], heuristic[j] );
				System.out.println("solve " + bench[i] + " with " + model);
				model.buildModel(modeltype[j]);
				model.setTimeLimit(timelimit);
				model.solve();

		        time[i][j] = model.getTime();
		        node[i][j] = model.getNode();
		        iteration[i][j] = (model.nIterations + 1);
		        nogood[i][j] = model.nNogoods;
		        //score[i][j] = model.softCost;


		        if( model.isFeasible ) {

		        	model.checkSolution();
			        System.out.print("SAT     ");

		        } else System.out.print("UNKnown ");
		        System.out.println( node[i][j] + " NDS, " + time[i][j] + " ms, "
		        		+ (model.nIterations + 1) + " iterations, "
		        		+ model.nNogoods + " nogoods learned\n" );
			}


			for(int j = nhModels+nlModels; j < nhModels+nlModels+nsModels; j++)
			{


				SoftLightModel model = new SoftLightModel( bench[i], heuristic[j] );
				System.out.println("solve " + bench[i] + " with " + model);
				SoftSolver.optHeuristic = false;
				model.buildModel(modeltype[j]);
				model.setTimeLimit(timelimit);

				if( j == nhModels+nlModels )
					model.solve();
				else if ( j == nhModels+nlModels+1 )
					model.solveLDS(5);
				else
					model.solveLDS();

				SoftSolver.optHeuristic = false;
		        time[i][j] = model.getTime();
		        node[i][j] = model.getNode();
		        iteration[i][j] = (model.nIterations + 1);
		        nogood[i][j] = model.nNogoods;
		        score[i][j] = model.softCost;


		        if( model.isFeasible ) {

		        	model.checkSolution();
			        System.out.print("SAT     ");

		        } else System.out.print("UNKnown ");
		        System.out.println( node[i][j] + " NDS, " + time[i][j] + " ms, "
		        		+ (model.nIterations + 1) + " iterations, "
		        		+ model.nNogoods + " nogoods learned\n" );
			}

		}
		displayTex();
	}


	public void displayTex()
	{

//		/// Model table
//
//		System.out.print("\\begin{table}[htbp]\n\\begin{small}\n\\begin{center}\n\\begin{tabular}{l|");
//
//		for(int j = 0; j < 4; j++)
//		{
//			System.out.print( "rrrr|" );
//		}
//		System.out.print( "}\n\\hline\n" );
//
//		for(int j = 0; j < 4; j++)
//		{
//			System.out.print("& \\multicolumn{4}{c|}{" + modelname[j] + "}" );
//		}
//		System.out.println("\\\\\n");
//		for(int j = 0; j < 4; j++)
//		{
//			System.out.print(" ~& iter ~&& time ~& nodes " );
//		}
//
//		System.out.println("\\\\\n\\hline\n");
//		for(int i = 0; i < nBenchs; i++)
//		{
//			System.out.print( "Inst-" + bench[i].substring(24, 26) );
//			for(int j = 0; j < 4; j++)
//			{
//				System.out.print(" ~& " + iteration[i][j] + " ~&& " + ((double)(time[i][j])/(double)1000) + " ~& " + node[i][j]);
//			}
//			System.out.println("\\\\\n\\hline\n");
//		}
//
//		System.out.print("\\end{tabular}\n\\end{center}\n\\end{small}\n\\caption{Models \\label{models}}\n\\end{table}\n");
//
//
//		/// Heuristic table
//
//
//		System.out.print("\\begin{table}[htbp]\n\\begin{small}\n\\begin{center}\n\\begin{tabular}{l|");
//
//		for(int j = 3; j < 6; j++)
//		{
//			System.out.print( "rrrr|" );
//		}
//		System.out.print( "}\n\\hline\n" );
//
//		for(int j = 3; j < 6; j++)
//		{
//			System.out.print("& \\multicolumn{4}{c|}{" + modelname[j] + "}" );
//		}
//		System.out.println("\\\\\n");
//		for(int j = 3; j < 6; j++)
//		{
//			System.out.print(" ~& iter ~&& time ~& nodes " );
//		}
//
//		System.out.println("\\\\\n\\hline\n");
//		for(int i = 0; i < nBenchs; i++)
//		{
//			System.out.print( "Inst-" + bench[i].substring(24, 26) );
//			for(int j = 3; j < 6; j++)
//			{
//				System.out.print(" ~& " + iteration[i][j] + " ~&& " + ((double)(time[i][j])/(double)1000) + " ~& " + node[i][j]);
//			}
//			System.out.println("\\\\\n\\hline\n");
//		}
//
//		System.out.print("\\end{tabular}\n\\end{center}\n\\end{small}\n\\caption{Heuristics \\label{heuristics}}\n\\end{table}\n");
//
//
//
		/// Soft cost table

		System.out.print("\\begin{table}[htbp]\n\\begin{small}\n\\begin{center}\n\\begin{tabular}{l|");

		for(int j = nhModels+nlModels; j < nhModels+nlModels+nsModels; j++)
		{
			System.out.print( "r|" );
		}
		System.out.print( "}\n\\hline\n" );

		for(int j = nhModels+nlModels; j < nhModels+nlModels+nsModels; j++)
		{
			System.out.print("& " + modelname[j]  );
		}

		System.out.println("\\\\\n\\hline\n");
		for(int i = 0; i < nBenchs; i++)
		{
			System.out.print( "Inst-" + bench[i].substring(24, 26) );
			for(int j = nhModels+nlModels; j < nhModels+nlModels+nsModels; j++)
			{
				System.out.print(" ~& " + score[i][j] );
			}
			System.out.println("\\\\\n\\hline\n");
		}

		System.out.print("\\end{tabular}\n\\end{center}\n\\end{small}\n\\caption{Cost \\label{cost}}\n\\end{table}\n");

//
//
//		System.out.print("\\begin{table}[htbp]\n\\begin{small}\n\\begin{center}\n\\begin{tabular}{l|");
//
//		for(int j = 0; j < nlModels; j++)
//		{
//			System.out.print( "rrrr|" );
//		}
//		System.out.print( "}\n\\hline\n" );
//
//		for(int j = 0; j < nlModels; j++)
//		{
//			System.out.print("& \\multicolumn{4}{c|}{" + modelname[j] + "}" );
//		}
//		System.out.println("\\\\\n");
//		for(int j = 0; j < nlModels; j++)
//		{
//			System.out.print(" ~& cost ~&& time ~& nodes " );
//		}
//
//		System.out.println("\\\\\n\\hline\n");
//		for(int i = 0; i < nBenchs; i++)
//		{
//			System.out.print( "Inst-" + bench[i].substring(24, 26) );
//			for(int j = 0; j < nlModels; j++)
//			{
//				System.out.print(" ~& " + score[i][j] + " ~&& " + (time[i][j]/1000) + " ~& " + node[i][j]);
//			}
//			System.out.println("\\\\\n\\hline\n");
//		}
//
//		System.out.print("\\end{tabular}\n\\end{center}\n\\end{small}\n\\caption{Models \\label{models}}\n\\end{table}\n");
//
//

//		System.out.print("\\begin{table}[htbp]\n\\begin{small}\n\\begin{center}\n\\begin{tabular}{l|");
//
//		for(int j = 3; j < 6; j++)
//		{
//			System.out.print( "rrr|" );
//		}
//		System.out.print( "}\n\\hline\n" );
//
//		for(int j = 3; j < 6; j++)
//		{
//			System.out.print("& \\multicolumn{3}{c|}{" + modelname[j] + "}" );
//		}
//		System.out.println("\\\\\n");
//		for(int j = 3; j < 6; j++)
//		{
//			System.out.print("& time & nodes & iter " );
//		}
//
//		System.out.println("\\\\\n\\hline\n");
//		for(int i = 0; i < nBenchs; i++)
//		{
//			System.out.print( "Inst-" + bench[i].substring(24, 25) );
//			for(int j = 3; j < 6; j++)
//			{
//				System.out.print(" & " + time[i][j] + " & " + node[i][j] + " & " + iteration[i][j]);
//			}
//			System.out.println("\\\\\n\\hline\n");
//		}
//
//		System.out.print("\\end{tabular}\n\\end{center}\n\\end{small}\n\\caption{Heuristics \\label{heuristics}}\n\\end{table}\n");
//


//		System.out.print("\\begin{table}[t]\n\\begin{center}\n\\begin{tabular}{l|");
//
//		for(int j = 0; j < nhModels+nlModels; j++)
//		{
//			System.out.print( "rrr|" );
//		}
//		System.out.print( "}\n\\hline\n" );
//
//		for(int j = 0; j < nhModels+nlModels; j++)
//		{
//			System.out.print("& \\multicolumn{3}{c}{" + modelname[j] + "}" );
//		}
//		System.out.println("\\\\\n\\hline\n");
//		for(int i = 0; i < nBenchs; i++)
//		{
//			System.out.print( bench[i].substring(12) );
//			for(int j = 0; j < nhModels+nlModels; j++)
//			{
//				System.out.print(" & " + time[i][j] );
//			}
//			System.out.println("\\\\\n\\hline\n");
//		}
//
//		System.out.print("\\end{tabular}\n\\end{center}\n\\caption{cpu time \\label{time}}\n\\end{table}\n");
//
//		System.out.print("\n\n\\begin{table}[t]\n\\begin{center}\n\\begin{tabular}{l|");
//
//		for(int j = 0; j < nhModels+nlModels; j++)
//		{
//			System.out.print( "c|" );
//		}
//		System.out.print( "}\n\\hline\n" );
//
//		for(int j = 0; j < nhModels+nlModels; j++)
//		{
//			System.out.print(" & " + modelname[j] );
//		}
//		System.out.println("\\\\\n\\hline\n");
//		for(int i = 0; i < nBenchs; i++)
//		{
//			System.out.print( bench[i].substring(12) );
//			for(int j = 0; j < nlModels; j++)
//			{
//				System.out.print("& " + node[i][j] );
//			}
//			System.out.println("\\\\\n\\hline\n");
//		}
//
//		System.out.print("\\end{tabular}\n\\end{center}\n\\caption{nodes \\label{node}}\n\\end{table}\n");
//
//		System.out.print("\n\n\\begin{table}[t]\n\\begin{center}\n\\begin{tabular}{l|");
//
//		for(int j = 0; j < nhModels+nlModels; j++)
//		{
//			System.out.print( "c|" );
//		}
//		System.out.print( "}\n\\hline\n" );
//
//		for(int j = 0; j < nhModels+nlModels; j++)
//		{
//			System.out.print(" & " + modelname[j] );
//		}
//		System.out.println("\\\\\n\\hline\n");
//		for(int i = 0; i < nBenchs; i++)
//		{
//			System.out.print( bench[i].substring(12) );
//			for(int j = 0; j < nhModels+nlModels; j++)
//			{
//				System.out.print("& " + iteration[i][j] + " / " + nogood[i][j] );
//			}
//			System.out.println("\\\\\n\\hline\n");
//		}
//
//		System.out.print("\\end{tabular}\n\\end{center}\n\\caption{iterations/nogoods \\label{iterations}}\n\\end{table}\n");
	}


	public static void main(String[] args) {
		CPBenchmark cpb = new CPBenchmark();
		cpb.setSoftExp();
		cpb.launch();
		//cpb.display();
	}


//	public static void main(String[] args) {
//
//		HeavyModel model = new HeavyModel( "data/Track2/comp-2007-2-3.tim" );
//		System.out.println("solve " + "data/Track2/comp-2007-2-3.tim" + " with heavy model");
//
//		model.buildModel();
//		model.setTimeLimit(300000);
//        model.solve();
//
//	}




	// scaled 5, 3 days 4 hours
//	dom/deg + lex          :	 60000	904	5269	19402	60000	60000	4	2
//	dom/deg + contention   :	 60000	905	5277	19441	60000	60000	5	1
//	contention + lex       :	 60000	657	3905	12062	60000	60000	4	2
//	contention + contention:	 60000	663	3921	12069	60000	60000	3	3

	// scaled 2, 5 days 5 hours
//	dom/deg + lex          :	 60001	60000	60000	60000	122	16965	60000	26
//	dom/deg + contention   :	 60000	60000	60000	60000	370	1779	60000	34
//	contention + lex       :	 60000	60000	60000	907	60001	234	60001	26
//	contention + contention:	 60000	60000	60000	60000	60001	60001	30304	27


//	solve data/Track2/comp-2007-2-1.tim with dom/deg + lex
//	start solve nbc: 46 nbv: 401
//	322609 300002
//	solve data/Track2/comp-2007-2-1.tim with dom/deg + contention
//	start solve nbc: 46 nbv: 401
//	249119 300002
//	solve data/Track2/comp-2007-2-1.tim with contention + lex
//	start solve nbc: 46 nbv: 401
//	358797 300003
//	solve data/Track2/comp-2007-2-1.tim with contention + contention
//	start solve nbc: 46 nbv: 401
//	300876 300002
//	solve data/Track2/comp-2007-2-2.tim with dom/deg + lex
//	start solve nbc: 46 nbv: 401
//	27420420 300002
//	solve data/Track2/comp-2007-2-2.tim with dom/deg + contention
//	start solve nbc: 46 nbv: 401
//	199498 300002
//	solve data/Track2/comp-2007-2-2.tim with contention + lex
//	start solve nbc: 46 nbv: 401
//	330124 300002
//	solve data/Track2/comp-2007-2-2.tim with contention + contention
//	start solve nbc: 46 nbv: 401
//	268220 300002

//	solve data/Track2/comp-2007-2-6.tim with dom/deg + lex
//	start solve nbc: 46 nbv: 401
//	395 465
//	solve data/Track2/comp-2007-2-6.tim with dom/deg + contention
//	start solve nbc: 46 nbv: 401
//	382 397
//	solve data/Track2/comp-2007-2-6.tim with contention + lex
//	start solve nbc: 46 nbv: 401
//	394 393
//	solve data/Track2/comp-2007-2-6.tim with contention + contention
//	start solve nbc: 46 nbv: 401
//	396 398
//	solve data/Track2/comp-2007-2-7.tim with dom/deg + lex
//	start solve nbc: 46 nbv: 201
//	448678 300000
//	solve data/Track2/comp-2007-2-7.tim with dom/deg + contention
//	start solve nbc: 46 nbv: 201
//	136899 117718
//	solve data/Track2/comp-2007-2-7.tim with contention + lex
//	start solve nbc: 46 nbv: 201
//	1459 1152
//	solve data/Track2/comp-2007-2-7.tim with contention + contention
//	start solve nbc: 46 nbv: 201
//	175 99
//	solve data/Track2/comp-2007-2-8.tim with dom/deg + lex
//	start solve nbc: 46 nbv: 201
//	1182763 300001
//	solve data/Track2/comp-2007-2-8.tim with dom/deg + contention
//	start solve nbc: 46 nbv: 201
//	235 130
//	solve data/Track2/comp-2007-2-8.tim with contention + lex
//	start solve nbc: 46 nbv: 201
//	174 104
//	solve data/Track2/comp-2007-2-8.tim with contention + contention
//	start solve nbc: 46 nbv: 201
//	201 88


//	solve data/Track2/comp-2007-2-3.tim with contention/deg + contention
//	rooms: 21 200
//	start solve nbc: 68 nbv: 203
//		propagate
//	found a coloring
//		found an improving solution: 2147483647 -> 730 - 7351ms
//		found an improving solution: 730 -> 729 - 7364ms
//		found an improving solution: 729 -> 715 - 7370ms
//		found an improving solution: 715 -> 714 - 7374ms
//		found an improving solution: 714 -> 708 - 7382ms
//		found an improving solution: 708 -> 707 - 7388ms
//		found an improving solution: 707 -> 706 - 7400ms
//		found an improving solution: 706 -> 705 - 7409ms
//		found an improving solution: 705 -> 704 - 7414ms
//		found an improving solution: 704 -> 703 - 7419ms
//		found an improving solution: 703 -> 702 - 74208ms
//		found an improving solution: 702 -> 698 - 7437ms
//		found an improving solution: 698 -> 697 - 74420ms
//		found an improving solution: 697 -> 696 - 7458ms
//		found an improving solution: 696 -> 689 - 7468ms
//		found an improving solution: 689 -> 688 - 7473ms
//		found an improving solution: 688 -> 687 - 7478ms
//		found an improving solution: 687 -> 686 - 7484ms
//		found an improving solution: 686 -> 685 - 7492ms
//		found an improving solution: 685 -> 684 - 7496ms
//		found an improving solution: 684 -> 683 - 7510ms
//		found an improving solution: 683 -> 682 - 7517ms
//		found an improving solution: 682 -> 681 - 7524ms
//		found an improving solution: 681 -> 680 - 7533ms
//		found an improving solution: 680 -> 679 - 7540ms
//		found an improving solution: 679 -> 677 - 7546ms
//		found an improving solution: 677 -> 676 - 7556ms
//		found an improving solution: 676 -> 675 - 7564ms
//		found an improving solution: 675 -> 674 - 7569ms
//		found an improving solution: 674 -> 673 - 7576ms
//		found an improving solution: 673 -> 672 - 7587ms
//		found an improving solution: 672 -> 671 - 7597ms
//		found an improving solution: 671 -> 670 - 7604ms
//	found a coloring
//		found an improving solution: 670 -> 669 - 7626ms
//		found an improving solution: 669 -> 668 - 7634ms
//		found an improving solution: 668 -> 667 - 7641ms
//		found an improving solution: 667 -> 662 - 7649ms
//		found an improving solution: 662 -> 661 - 7652ms
//		found an improving solution: 661 -> 660 - 7659ms
//		found an improving solution: 660 -> 659 - 7662ms
//		found an improving solution: 659 -> 657 - 7670ms
//		found an improving solution: 657 -> 656 - 7677ms
//		found an improving solution: 656 -> 655 - 7692ms
//		found an improving solution: 655 -> 654 - 7694ms
//		found an improving solution: 654 -> 653 - 7708ms
//		found an improving solution: 653 -> 652 - 7719ms
//		found an improving solution: 652 -> 651 - 7731ms
//		found an improving solution: 651 -> 650 - 7763ms
//		found an improving solution: 650 -> 649 - 7771ms
//		found an improving solution: 649 -> 648 - 75266ms
//		found an improving solution: 648 -> 647 - 75281ms
//		found an improving solution: 647 -> 646 - 80069ms
//		found an improving solution: 646 -> 645 - 80082ms
//		found an improving solution: 645 -> 644 - 101641ms
//		found an improving solution: 644 -> 643 - 101656ms
//		found an improving solution: 643 -> 6420 - 101671ms
//		found an improving solution: 6420 -> 641 - 101686ms
//		found an improving solution: 641 -> 640 - 101704ms
//		found an improving solution: 640 -> 639 - 101718ms
//		found an improving solution: 639 -> 638 - 101730ms
//		found an improving solution: 638 -> 637 - 101745ms
//		found an improving solution: 637 -> 636 - 101765ms
//		found an improving solution: 636 -> 635 - 101784ms
//		found an improving solution: 635 -> 634 - 101799ms



}
