package cpmodel.heuristics;

import choco.Problem;
import choco.integer.IntDomainVar;
import choco.integer.search.AbstractIntVarSelector;
import choco.mem.IStateInt;

public class MinDomPrint extends AbstractIntVarSelector {
	/**
	 * the sequence of variables that need be instantiated
	 */
	protected IntDomainVar[] vars;
	protected int nHours;
	protected int nDays;
	protected int nEvents;
	protected int nRooms;
	protected int type;

	//protected Set<Integer>[] timetable; 
	protected int[][] lbEvents;
	protected int[][] ubEvents;

	public MinDomPrint(IntDomainVar[] vars) {
		this.vars = vars;
	}

	public MinDomPrint(Problem pb, IntDomainVar[] vars, 
			int nh, int nd, int ne, int nr, int t) {
		nHours = nh;
		nDays = nd;
		nEvents = ne;
		nRooms = nr;
		type = t;
		lbEvents = new int[nHours * nDays][nEvents];
		ubEvents = new int[nHours * nDays][nEvents];
		
//		for(int i=0; i<nHours*nDays; i++) {
//		lbEvents[i] = new int[nEvents];
//		ubEvents[i] = new int[nEvents];
//		}

//		timetable = new HashSet[nHours * nDays];
//		for(int i=0; i<nHours*nDays; i++) {
//		timetable[i] = new HashSet<Integer>();
//		}

		this.vars = vars;
	}

	public IntDomainVar selectIntVar() {

//		if(type == 1) {
//		for(int i=0; i<nHours*nDays; i++) {
//		lbEvents[i] = new int[nEvents];
//		}
//		for (int i = 0; i < nEvents; i++) {
//		timetable[vars[i].getVal() - 1].add( i );
//		}
//		for(int i=0; i<nHours*nDays; i++) {
//		System.out.println( timetable[i] );
//		}
//		}

		if(type == 1) {
			
			System.out.println(nDays + " " + nHours);
			
			for(int i=0; i<nHours*nDays; i++) {
				for(int j=0; j<nEvents; j++) {
					lbEvents[i][j] = 0;
					ubEvents[i][j] = 0;
				}
			}


			for (int j=0; j<nEvents; j++) {
				IntDomainVar v = vars[j];
				if (!v.isInstantiated()) {
					int vnxt = v.getInf();
					int vali;
					do {
						vali = vnxt;
						ubEvents[vali-1][j] = 1;
						vnxt = v.getNextDomainValue(vali);
					} while( vali != v.getSup() );


				} else {
					lbEvents[v.getVal()-1][j] = 1;
					ubEvents[v.getVal()-1][j] = 1;
				}
			}


			for(int i=0; i<nHours*nDays; i++) {
				System.out.print("{");
				for(int j=0; j<nEvents; j++) {
					if( lbEvents[i][j] == 1 )
						System.out.print(" " + (j+1));
				}
				System.out.print(" } < T" + i + " < {");
				for(int j=0; j<nEvents; j++) {
					if( ubEvents[i][j] == 1 )
						System.out.print(" " + (j+1));
				}
				System.out.println(" }");
			}
		}

		int minValue = IStateInt.MAXINT;
		IntDomainVar v0 = null;
		for (IntDomainVar v:vars) {
			if (!v.isInstantiated()) {
				int val = v.getDomainSize();
				if (val < minValue)  {
					minValue = val;
					v0 = v;
				}
			}
		}


		int theval = (v0.getInf()-1);
		System.out.println("T" + theval + " += " + v0 + "\n");

		return v0;
	}

}
