package cpmodel.heuristics;

import choco.integer.search.ValSelector;
import choco.integer.IntDomainVar;
import choco.util.DisposableIntIterator;

import java.util.Random;

/**
 * Comment to Emmanuel : Comme il s'agit d'une interface ValSelector,
 * tu peux eventuellement ne faire qu'un seul objet qui extends DoubleHeuristicIntVarSelector et
 * implement ValSelector. Comme ca tu as pas a passer d'info d un objet a l autre !
 * */
public class MyValueSelector implements ValSelector {

	protected int useContention;
	protected double[] contention;

	public MyValueSelector(double[] c) {
		contention = c;
		useContention = 1;
	}

	public void setLex()
	{
		useContention = 0;
	}
	
	public void setCon()
	{
		useContention = 1;
	}
	
	//attention tu dois imperativement renvoyer une valeur qui est
	// dans le domaine de x !
	public int getBestVal(IntDomainVar x) {
		int bestval = x.getInf();

		if( useContention == 1 ) {
			int vali = bestval;
			do {
				if(contention[vali-1] < contention[bestval-1]) {
					bestval = vali;
				}
				vali = x.getNextDomainValue(vali);
			} while( vali <= x.getSup() );
		}
		
		return bestval;
//		return x.getInf();
	}

}
