/**
 * 
 */
package instance.clique;

import instance.ConflictGraph;

import java.util.BitSet;

public class ExtensionClique extends ElementaryClique{
	
	protected MaxCliqueFinder mc;
	protected BitSet nodes;
	
	public ExtensionClique(MaxCliqueFinder mc, BitSet nodes){
		this.mc = mc;
		this.nodes = nodes;
	}

	@Override
	public ConflictGraph getGraph() {
		return mc.getGraph();
	}

	@Override
	public int getSize() {
		return nodes.cardinality();
	}

	@Override
	public BitSet retrieveNodes() {
		BitSet tmp = new BitSet(getGraph().getNNodes());
		tmp.or(nodes);
		return tmp;
	}
	
}