/**
 * 
 */
package instance.clique;

import instance.ConflictGraph;
import instance.TimetablingInstance;

import java.util.BitSet;

import util.IntSet;

public class RoomClique extends ElementaryClique{
	
	protected MaxCliqueFinder mc;
	protected int room;
	
	public RoomClique(MaxCliqueFinder mc, int room){
		assert(mc.isCritical(room));
		
		this.mc = mc;
		this.room = room;			
	}
	
	public int getSize(){
		return mc.getEvents(room).size();
	}
	
	public BitSet retrieveNodes(){
		TimetablingInstance p = mc.getProblem();
		IntSet events = mc.getEvents(room);
		BitSet nodes = new BitSet(p.getNEvents());
		for(int e=events.first();e>-1;e=events.next(e))
			nodes.set(e);
		return nodes;
	}
	
	public ConflictGraph getGraph() {
		return mc.getGraph();
	}
}