/**
 * 
 */
package instance.clique;

import instance.ConflictGraph;

import java.util.BitSet;

public class StudentClique extends ElementaryClique{
	
	protected MaxCliqueFinder mc;
	protected int student;
	protected int size;
	
	public StudentClique(MaxCliqueFinder mc, int student){
		this.mc = mc;
		this.student = student;
		size = mc.getProblem().eventsAttendedByStudent(student).cardinality();
	}
	
	public int getSize(){
		return size;
	}
	
	public BitSet retrieveNodes(){
		BitSet nodes = new BitSet(mc.getProblem().getNEvents());
		nodes.or(mc.getProblem().eventsAttendedByStudent(student));
		return nodes;
	}

	public ConflictGraph getGraph() {
		return mc.getGraph();
	}
	
	
}