/**
 * 
 */
package instance.colouring;

import instance.ColourableConflictGraph;
import util.IntSet;

public class MinDomMaxDegSelector extends GraphColouring{

	public MinDomMaxDegSelector(ColourableConflictGraph graph) {
		super(graph);
	}

	protected int nextNode(){
		int min = graph.colourList(0).capacity()+1;
		IntSet minNodes = null;
		for (int node = unassignedNodes.first(); node >= 0; node = unassignedNodes.next(node)) {
			int size = graph.colourList(node).size();
			if(size < min){
				min = size;
				minNodes = new IntSet(graph.getNNodes());
				minNodes.setRandom(random);
			}
			if(size == min){
				minNodes.add(node);
			}
		}
		assert(minNodes != null);
		
		int max = 0;
		IntSet maxNodes = null;
		for(int node = minNodes.first(); node >=0 ;node = minNodes.next(node)){
			int deg = graph.getDegree(node);
			if(deg > max){
				max = deg;
				maxNodes = new IntSet(graph.getNNodes());
				maxNodes.setRandom(random);
			}
			if(deg == max){
				maxNodes.add(node);
			}
		}
		
		return maxNodes.randomValue();
	}
}