/**
 * 
 */
package instance.colouring;

import instance.ColourableConflictGraph;
import util.IntSet;

public class MinDomOverDegSelector extends GraphColouring{

	public MinDomOverDegSelector(ColourableConflictGraph graph) {
		super(graph);
	}

	protected int nextNode(){
		double min = Double.MAX_VALUE;
		IntSet minNodes = null;
		for (int node = unassignedNodes.first(); node >= 0; node = unassignedNodes.next(node)) {
			double size = (double)graph.colourList(node).size()/graph.getDegree(node);
			if(size < min){
				min = size;
				minNodes = new IntSet(graph.getNNodes());
				minNodes.setRandom(random);
			}
			if(size == min){
				minNodes.add(node);
			}
		}
		assert(minNodes != null);
		return minNodes.randomValue();
	}
}