/**
 * 
 */
package instance.colouring;

import instance.ColourableConflictGraph;
import util.IntSet;

public class MinNodeSelector extends GraphColouring{

	public MinNodeSelector(ColourableConflictGraph graph) {
		super(graph);
	}

	protected int nextNode(){
		int min = graph.colourList(0).capacity()+1;
		IntSet minNodes = null;
		for (int node = unassignedNodes.first(); node >= 0; node = unassignedNodes.next(node)) {
			int size = graph.colourList(node).size();
			if(size < min){
				min = size;
				minNodes = new IntSet(graph.getNNodes());
				minNodes.setRandom(random);
			}
			if(size == min){
				minNodes.add(node);
			}
		}
		assert(minNodes != null);
		return minNodes.randomValue();
	}
}