package localsearch.greedy.acogreedy;

import choco.ContradictionException;
import choco.Problem;
import choco.integer.IntDomainVar;
import choco.search.AbstractGlobalSearchLimit;
import choco.search.AbstractGlobalSearchSolver;

import java.util.Arrays;

/**
 * Created by IntelliJ IDEA.
 * User: hcambaza
 * Date: Sep 9, 2008
 * Time: 7:33:57 PM
 * To change this template use File | Settings | File Templates.
 */
public class CustomFailLimit extends AbstractGlobalSearchLimit {

    protected int[] eventTime;
    protected int solutionSize = -1;

    protected IntDomainVar[] eventTimeVar;

    protected Problem pb;


    public CustomFailLimit(AbstractGlobalSearchSolver theSolver, IntDomainVar[] eventTimeVar, int theLimit) {
		super(theSolver, theLimit);
		this.unit = "backtrack";
        this.eventTimeVar = eventTimeVar;
        this.eventTime = new int[eventTimeVar.length];
    }


    public int[] getPartialSolution() {
        return eventTime;
    }

    public boolean newNode(AbstractGlobalSearchSolver solver) {
        return ((nb + nbTot) < nbMax);
	}

	public boolean endNode(AbstractGlobalSearchSolver solver) {
        nb++;
        int solquality = countNbInstVar();
        if (solquality > solutionSize) {
            storeCurrentPartialSolution();
            solutionSize=solquality;
        }        
        return ((nb + nbTot) < nbMax);
	}

    public int countNbInstVar() {
        int nb = 0;
        for (int i = 0; i < eventTime.length; i++) {
            if (eventTimeVar[i].isInstantiated()) {
                nb++;
            }
        }
        return nb;
    }

    public void storeCurrentPartialSolution() {
        Arrays.fill(eventTime,-1);
        for (int i = 0; i < eventTime.length; i++) {
            if (eventTimeVar[i].isInstantiated()) {
//               System.out.print("["+i + ":" + (eventTimeVar[i].getVal() - 1) + "]");
               eventTime[i] = eventTimeVar[i].getVal() - 1;
            }
        }
    }
}
