package localsearch.metah;

import localsearch.solvers.complete.AbstractSolver;
import localsearch.SolutionSpace;
import localsearch.moves.complete.*;
import localsearch.moves.Move;

/**
 * Created by IntelliJ IDEA.
 * User: hcambaza
 * Date: 26 aot 2007
 * Time: 10:48:43
 * To change this template use File | Settings | File Templates.
 */
public abstract class MetaHeuristic {

    //reference to the search stateand the solver
    protected SolutionSpace space;
    protected AbstractSolver abs;


    protected MetaHeuristic(AbstractSolver abs) {
        this.abs = abs;
        this.space = abs.space;
    }

    //Aspiration criteria : check if the move can improve the best known solution
    public boolean aspiration(int delta) {
       return (abs.getCost() + delta) < abs.getBestCost();
    }

	public void reinit() {
		
	}

	public void initIntensification() {

	}

	public abstract void initMhParameters();

    public abstract boolean accept(SwapEvents swe, int delta);

	public abstract boolean accept(CPMove cpm, int delta);

    public abstract boolean accept(TranslateEvent tre, int delta);

	public abstract boolean accept(SwapTimeslots swt, int delta);

	public abstract boolean accept(VHungarianMove vmove, int delta);

    public abstract void informOfMove(Move mov);


}
