package localsearch.moves.coloring;

import localsearch.moves.complete.SwapTimeslots;
import localsearch.SolutionSpace;

import java.util.Arrays;

/**
 * Created by IntelliJ IDEA.
 * User: hcambaza
 * Date: Sep 28, 2008
 * Time: 7:09:27 PM
 * To change this template use File | Settings | File Templates.
 */
public class ColoringSwapTimeslots extends SwapTimeslots {

    public ColoringSwapTimeslots(SolutionSpace space) {
        super(space);
    }

    public void setT1(int t1) {
		this.t1 = t1;
		this.timet1 = space.listevts[t1];
	}

	public int getT2() {
		return t2;
	}

	public void setT2(int t2) {
		this.t2 = t2;
		this.timet2 = space.listevts[t2];
	}

	public void performMove() {
		int a = space.nbept[t1];
		int b = space.nbept[t2];
		int[] la = space.listevts[t1];
		int[] lb = space.listevts[t2];

        for (int i = 0; i < space.R; i++) {
			int e1i = timet1[i];
			int e2i = timet2[i];
            if (e1i != -1) {
				if (e2i != -1) {
					space.fastSwitchTimeslot(e1i, e2i);
				} else {
					space.fastMoveTimeslot(e1i, t2);
				}
			} else if (e2i != -1) {
				space.fastMoveTimeslot(e2i, t1);
			}
		}        
        for (int i = 0; i < space.R; i++) {
			int e2i = timet2[i];
			int e1i = timet1[i];
            if (e1i != -1) {
				space.maintainPrecedenceCostFromMove(e1i, t1, t2);
			}
			if (e2i != -1) {
				space.maintainPrecedenceCostFromMove(e2i, t2, t1);
			}
		}
		space.nbept[t2] = a;
		space.nbept[t1] = b;
		space.listevts[t1] = lb;
		space.listevts[t2] = la;
	}
}
