package localsearch.moves.coloring;

import localsearch.moves.complete.TranslateEvent;
import localsearch.solvers.coloring.HardColoringSolutionSpace;

/**
 * Created by IntelliJ IDEA.
 * User: hcambaza
 * Date: Sep 28, 2008
 * Time: 12:05:26 PM
 * To change this template use File | Settings | File Templates.
 */
public class ColoringTranslation extends TranslateEvent {

    public ColoringTranslation(HardColoringSolutionSpace space) {
        super(space);
    }

    public int getEvt() {
        return evt;
    }

    public void setEvt(int evt) {
        this.evt = evt;
        this.oldtimeslot = space.timeslot[evt];
    }

    public void setFromEvt(ColoringTranslation tre) {
        this.timeslot = tre.timeslot;
        this.delta = tre.delta;
    }

    public void setTimeslot(int t) {
        this.timeslot = t;
    }

    public String toString() {
        return "translate " + evt + " from timeslot " + oldtimeslot + " to timeslot " + timeslot + " for " + delta;
    }


    public int evalCostMove() {
        int e1t = space.timeslot[evt];
        assert (e1t != timeslot);
        //availability
        int ca = space.timeslotFeas[evt][timeslot];
        //neigbhours costs
        int cn = 0;
        for (int i = 0; i < space.nbept[timeslot]; i++) {
            int ei = space.listevts[timeslot][i];
            cn += space.conflicts[ei][evt];
        }
        int cglobal = ca + cn + space.evalPrecedenceCostFromMove(evt, -1, e1t, timeslot);
        delta = cglobal - space.eventcost[evt];
        return delta;
    }

    public void performMove() {
        //System.out.println("perform " + this);
        int e1t = space.timeslot[evt];
        space.removeEvent(evt);
        ((HardColoringSolutionSpace) space).addEvent(evt, timeslot);
        space.maintainPrecedenceCostFromMove(evt, -1, e1t, timeslot);
    }

}
