package localsearch.moves.coloring.softmoves;

import localsearch.moves.complete.softmoves.SoftTranslateEvent;
import localsearch.SolutionSpace;
import localsearch.solvers.complete.AbstractSolver;
import localsearch.solvers.coloring.ColoringSolutionSpace;

/**
 * Created by IntelliJ IDEA.
 * User: hcambaza
 * Date: Sep 29, 2008
 * Time: 6:38:46 PM
 * To change this template use File | Settings | File Templates.
 */
public class ColoringSoftTranslation extends SoftTranslateEvent {

    public ColoringSoftTranslation(SolutionSpace space) {
        this.id = AbstractSolver.TRANSLATE_EVENTS;
        this.space = space;
    }

    public void setEvt(int evt) {
        this.evt = evt;
        this.oldtimeslot = space.timeslot[evt];
        this.oldday = space.getDay(oldtimeslot);
    }

    public void setFromEvt(ColoringSoftTranslation tre) {
        this.timeslot = tre.timeslot;
        this.oldday = tre.oldday;
        this.newday = tre.newday;
        this.delta = tre.delta;
    }

    public boolean isKeepingFeas() {
        assert (space.timeslotFeas[evt][timeslot] == 0);
        if (space.nbept[timeslot] == space.R) //quick test of room availability
            return false;
        for (int i = 0; i < space.nbept[timeslot]; i++) {
            int ei = space.listevts[timeslot][i];
            if (space.conflicts[ei][evt] > 0) return false;
        }
        if (!space.evalFeasPrecedenceFromMove(evt, -1, oldtimeslot, timeslot))
            return false;
        return true;
    }

    /**
     * Perform the translation while maintaing the changes
     * over the events in the timeslot that might need to be moved
     * to satisfy the machting including the outsider event
     */
    public void performMove() {
        int oldcost = space.softObj; //for assertion
        //moving the outsider event
        int e1t = space.timeslot[evt];
        assert (e1t != timeslot);
        space.softRemoveEvent(evt);
        ((ColoringSolutionSpace) space).softAddEvent(evt, timeslot); //todo
        if (oldday != newday) {
            space.removeEventSoftCost(evt, e1t);
            space.addEventSoftCost(evt, timeslot);
        } else {
            space.fastRemoveEventSoftCost(evt, e1t);
            space.fastAddEventSoftCost(evt, timeslot);
        }
        //space.assertAllSoftCosts();
        assert (oldcost + delta == space.softObj);
    }

}
