package timetabling.export;

import java.io.*;

import javax.swing.*;

import timetabling.graphics.*;
import timetabling.recover.DiaryConst;

public class CreationExportFile implements DiaryConst
{
	private DiaryTimeslot[] timeTabling;
	
	private FileWriter fileOut;
	private DiaryFileFilter zFilter = new DiaryFileFilter(".ics",  "iCalendar File");
	
	private JFileChooser chooser;
	
	public CreationExportFile(DiaryFrame diaryFrame)
	{
		timeTabling = diaryFrame.getTimeTabling().getTimeTabling();
	}

	public void createFile()
	{
		chooser = new JFileChooser();
		chooser.setCurrentDirectory(new File("./data"));
		chooser.setFileFilter(zFilter);
		chooser.setAcceptAllFileFilterUsed(false);
		int returnVal = chooser.showSaveDialog(null);
		
		if (returnVal==JFileChooser.APPROVE_OPTION)
		{
			String name = chooser.getSelectedFile().getPath();
			if(timeTabling != null)
				try 
				{
					fileOut = new FileWriter(new File(name+".ics"));
						
					String string = "BEGIN:VCALENDAR\n"
				           +"VERSION:2.0\n"
				           +"PRODID:-//hacksw/handcal//NONSGML v1.0//EN\n";
					
					for(int i = 0; i < days.length; i++)			
						for(int j = 0; j < nbHour; j++)
							if(timeTabling[j+(nbHour*i)] != null && timeTabling[j+(nbHour*i)].getListEvent().size() != 0)
							{
								string += "BEGIN:VEVENT\n"
									   +"DTSTART:";
									
								String string2 = "200905"+testDateHour(18+i)+"T";
									
								int hour = (1*j)+8;
								string2 += testDateHour(hour);
								
								string += string2+"0000Z\n"
									   +"DTEND:"+string2+"5959Z\n"
									   +"DESCRIPTION:"
									   +"Event(s) ("+timeTabling[j+(nbHour*i)].getListEvent().size()+") in this timeslot : ";
								
								String stringEvent = "";
								for(int length = 0; length < timeTabling[j+(nbHour*i)].getListEvent().size(); length++)
								{
									if(stringEvent != "")
										stringEvent += " - ";
									
									stringEvent += "Event n"+timeTabling[j+(nbHour*i)].getListEvent().get(length)
										   +" in the room "+timeTabling[j+(nbHour*i)].getListRoom().get(length);
								}
								
								string += stringEvent+"\nSUMMARY:Events during the timeslot n"+(j+(nbHour*i))+"\n"
							           +"END:VEVENT\n";
							}
				
					string += "END:VCALENDAR";
					fileOut.write(string);
			            
					fileOut.close();
					JOptionPane.showMessageDialog(null,
							"The file have been correctly created", "Export file saving", JOptionPane.INFORMATION_MESSAGE);	
				} 
		            
				catch (IOException e) 
				{
					JOptionPane.showMessageDialog(null,
							"An error has been meeting : Please retry", "Export file saving", JOptionPane.INFORMATION_MESSAGE);
				}
		}
	}
	
	public String testDateHour(int time)
	{
		String res;
		
		if(time < 10)
			res = "0"+time;
		else res = String.valueOf(time);
		return res;
	}

	public void setTimeTabling(DiaryTimeslot[] timeTabling) 
	{
		this.timeTabling = timeTabling;
	}
}