package timetabling.graphics;

import javax.swing.*;

public class DiaryBar extends JMenuBar
{
	private static final long serialVersionUID = 1L;
	
	private JMenu[] menus; 
	
	// Differents boutons de la barre principale.
	private JMenuItem openInstance, openSolution, close;
	private JMenuItem impFrame;
	private JMenuItem about;
	
	public DiaryBar(DiaryFrame frame)
	{
		menus = new JMenu[3];
		
		//----- File Menu -----\\
		menus[0] = new JMenu("File");
		menus[0].setMnemonic('F');
		this.add(menus[0]);
		
		// Open instance button
		openInstance = new JMenuItem("Open a new Instance");
		openInstance.setAccelerator(KeyStroke.getKeyStroke("ctrl O"));
		menus[0].add(openInstance);
		openInstance.setActionCommand("O");
		openInstance.addActionListener(frame);
		
		// Open solved file button
		openSolution = new JMenuItem("Open a solution File");
		openSolution.setAccelerator(KeyStroke.getKeyStroke("ctrl L"));
		menus[0].add(openSolution);
		openSolution.setActionCommand("L");
		openSolution.addActionListener(frame);
		
		// Close button
		close = new JMenuItem("Close");
		close.setAccelerator(KeyStroke.getKeyStroke("alt F4"));
		menus[0].add(close);
		close.addActionListener(frame);
		
		//----- Edit Menu -----\\
		menus[1] = new JMenu("Edit");
		menus[1].setMnemonic('E');
		this.add(menus[1]);
		
		// Register of the frame into a picture
		impFrame = new JMenuItem("Frame's screenshot");
		menus[1].add(impFrame);
		impFrame.setActionCommand("S");
		impFrame.addActionListener(frame);
		
		//----- Help Menu -----\\
		menus[2] = new JMenu("Help");
		menus[2].setMnemonic('H');
		this.add(menus[2]);
		
		// About button
		about = new JMenuItem("About");
		menus[2].add(about);
		about.addActionListener(frame);
	}
}
