package timetabling.graphics;

import java.awt.GridLayout;

import javax.swing.*;

public class DiaryFileSettings extends JPanel
{
	private static final long serialVersionUID = 1L;
	
	private int[] settings;
	private JLabel[] describeSettings;
	private JTextField[] displaySettings;
	
	private DiaryFrame diaryFrame;
	
	public DiaryFileSettings(DiaryFrame diaryFrame)
	{
		this.diaryFrame = diaryFrame;
		settings = new int[4];
		
		describeSettings = new JLabel[4];
		displaySettings = new JTextField[4];
		
		this.setLayout(new GridLayout(4, 2, 0, 5));
		
		String[] labelContent = {"Number of Events :", "Number of Rooms :",
				"Number of Features :", "Number of Students : "};
		
		for(int i = 0; i < settings.length; i ++)
		{
			settings[i] = 0;
			
			describeSettings[i] = new JLabel(labelContent[i]);
			this.add(describeSettings[i]);
			
			displaySettings[i] = new JTextField(String.valueOf(settings[i]));
			displaySettings[i].setEditable(false);
			this.add(displaySettings[i]);
		}
	}
	
	public void setSettings(int[] settings)
	{
		for(int i = 0; i < settings.length; i++)
		{
			this.settings[i] = settings[i];
			displaySettings[i].setText(String.valueOf(this.settings[i]));
		}
	}
	
	public int[] getSettings()
	{
		return settings;
	}
	
	public void changeStatus()
	{
		for(int i = 0; i < displaySettings.length; i++)
			displaySettings[i].setEnabled(!diaryFrame.superFrame.isVisible());
	}
}
