package timetabling.graphics;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;

import timetabling.recover.*;

public class DiaryGlassPane extends JPanel implements ActionListener 
{
	private static final long serialVersionUID = 1L;
	
	private DiaryFrame frame;
	
	private JPanel subpane;
	
	private JButton stop;
	private Chrono timer;
    private CostObserver cob;
	
    public DiaryGlassPane(DiaryFrame frame) 
    {    	
    	this.frame = frame;		
    	this.setBounds(0, 0, frame.getWidth(), frame.getHeight());
    	this.setBackground(new Color(180, 200, 240, 150));
    	this.setLayout(null);
    	
    	subpane = new JPanel();
    	subpane.setBorder(BorderFactory.createTitledBorder("Process in progress"));
    	subpane.setLayout(new GridLayout(4, 1, 5, 5));
    	subpane.setBackground(new Color(180, 200, 240));
    	subpane.setBounds((frame.getWidth()-300)/2, (frame.getHeight()-300)/2, 300, 150);
    	this.add(subpane);
    	
    	Font font = new Font("Arial", Font.ROMAN_BASELINE, 16);
    	this.subpane.setFont(font);
    	
    	timer = new Chrono();
    	this.subpane.add(timer);
    	
    	cob = new CostObserver();
        this.subpane.add(cob);
    	
	    stop = new JButton("Stop the treatment");
	    stop.setBackground(Color.white);
	    stop.setCursor(new Cursor(Cursor.HAND_CURSOR));
	    stop.addActionListener(this);
	    this.subpane.add(stop);
    }

    public CostObserver getCostObserver()
    {
        return cob;
    }
    
    public void paintComponent(Graphics g)
    {
    	g.setColor(new Color(180, 200, 240, 150));
    	g.fillRect(this.getBounds().x,this.getBounds().y,this.getBounds().width,this.getBounds().height);
    	g.fillRoundRect(((frame.getWidth()-300)/2)-2, ((frame.getHeight()-300)/2)-2, 305, 155, 5, 5);
    }
    
    public void Modify(DiaryTreatmentSettings settings, SolverThread launchTreatment)
    {
    	this.setVisible(true);
    	
    	timer.start(settings.timelimit);
    	cob.start(launchTreatment);
    }
    
    public void finalStop()
	{
		timer.stop();
		cob.stop();
		this.setVisible(false);
	}
    
	public void actionPerformed(ActionEvent event)
	{
		frame.stopResolution();
	}
}
