package timetabling.graphics;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.ParseException;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import timetabling.recover.DiaryConst;

public class DiaryTreatmentSettings extends JPanel implements DiaryConst, ActionListener, ChangeListener
{
	private static final long serialVersionUID = 1L;
	
	public long timelimit;
	public boolean hardSolver, hardPrediction;
	
	private JSpinner timeLimiter;
	private JCheckBox info1, info2;
	
	private DiaryFrame diaryFrame;
	
	public DiaryTreatmentSettings(DiaryFrame diaryFrame)
	{
		this.diaryFrame = diaryFrame;
		timelimit = 0;
		hardSolver = false;
		hardPrediction = false;
		
		this.setLayout(new GridLayout(3, 1));
		
		timeLimiter = new JSpinner(new SpinnerNumberModel(0, 0, 3600, 1));
		timeLimiter.addChangeListener(this);
		this.add(timeLimiter);
		
		info1 = new JCheckBox("Hard Solver");
		info1.addActionListener(this);
		this.add(info1);
		
		info2 = new JCheckBox("Hard Prediction");
		info2.addActionListener(this);
		this.add(info2);
	}

	public void stateChanged(ChangeEvent event) 
	{
		if(event.getSource() == timeLimiter)
		{
			try {
				timeLimiter.commitEdit();
			} catch (ParseException e) {
				e.printStackTrace();
			}
			timelimit = (Integer) timeLimiter.getValue();
		}
	}

	public void actionPerformed(ActionEvent event)
	{
		if(info1.isSelected())
			hardSolver = true;
		else hardSolver = false;
		
		if(info2.isSelected())
			hardPrediction = true;
		else hardPrediction = false;
	}
	
	public void changeStatus()
	{
		boolean glassPaneVisible = diaryFrame.superFrame.isVisible();
		
		timeLimiter.setEnabled(!glassPaneVisible);
		info1.setEnabled(!glassPaneVisible);
		info2.setEnabled(!glassPaneVisible);
	}
}
