package timetabling.recover;

import javax.swing.*;

public class Chrono extends JLabel implements Runnable
{
	private static final long serialVersionUID = 1L;
	
	private long time;
	private boolean running;
	private Thread runner;
	
	public Chrono()
	{
		time = 0;
		running = false;
		runner = null;
	}
	
	public void start(long time)
	{	
		this.time = time;
		this.setHorizontalAlignment(SwingConstants.CENTER);
		this.setHorizontalTextPosition(SwingConstants.CENTER);
		this.setText("Remaining Time : "+time+" seconds");
		if (runner==null)
		{
			running = true;
			runner = new Thread(this);
		    runner.start();
		}
	}
	
	public void stop ()
	{
		running = false;
		runner = null;
		this.validate();
	}

	public void run()
	{
		while(time != 0 && running)
		{
			time--;
			repaint();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			this.setText("Remaining Time : "+time+" seconds");
		}
	}
}