package timetabling.recover;

import localsearch.solvers.complete.SearchLoop;
import javax.swing.*;

public class CostObserver extends JLabel implements Runnable 
{
    private static final long serialVersionUID = 1L;

    private boolean running;
    private Thread runner;

    protected SearchLoop ssloop;
    protected SolverThread st;

    public CostObserver()
    {
    	st = null;
        running = false;
        runner = null;
    }

    public void start(SolverThread ssl) 
    {
    	st = ssl;
        this.setHorizontalAlignment(SwingConstants.CENTER);
		this.setHorizontalTextPosition(SwingConstants.CENTER);
        this.setText("Feasible solution : Not yet");

            running = true;
            runner = new Thread(this);
            runner.start();
        
    }

    public void run()
    {
        while (!st.searchOver && running) 
        {
            repaint();
            try {
                Thread.sleep(100);
            } catch (InterruptedException e)
            { e.printStackTrace();}
            
            ssloop = st.ssloop;
            if (ssloop != null)
                if (ssloop.hardS != null && ssloop.hardS.getBestCost() != 0) 
                    this.setText("Feasible solution : Not yet");
                else 
                	if (ssloop.softS != null)
                		this.setText("Feasible solution : YES - Cost = " + ssloop.softS.getBestCost());
                	else this.setText("Information unsure");
        }
    }

    public void stop() 
    {
        running = false;
        this.validate();
    }
}
